/*
*  This script defines functions used to show and to remove duplicates within ManageDuplicates.xul
*
* Author: Stphane BERTIN
* http://bookmarkdd.mozdev.org
*
*/

var URLnum = 0;
var DupNum = 0;
var Totalnum = 0;
var AutoDeletedBookmarkSameFolder= 0;
var AutoDeletedBookmarkSelectedFolder= 0;
var URLParents = new Array();
var URLrdfNodes = new Array();
var SelectedURL = "";
var rssFeed = /(.rss)$/i;	//Verify if url is a FeedURL
var isNotRootFolder = /( \> )/;		//if there is ' > ' it is not the root folder.

var DuplicatesBundle = document.getElementById('duplicates-strings');
var URLlist = document.getElementById("URLlist");
var FolderslistID = document.getElementById("Folderslist");
var BookmarksCount = document.getElementById("bookmarks_count");

var AutoDeleteSameFolder = UserPrefs.getPref("bool","AutoDelete.BookmarkInSameFolder");
var AutoDeleteSelectedFolder = UserPrefs.getPref("bool","AutoDelete.BookmarkInSelectedFolder");

var AutoDeleteAllDuplicates = false;

const TRUNCATENUM = UserPrefs.getPref("int","URL.truncateNum");

// Get Bookmarks Service
try {
    var bmsvc = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);
} catch(ex) {
    alert("Could not get nav-bookmarks-service\n");
}

// Get IO Service : used for newURI
var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);

// Used to get return of openbmProperties
var Bookmarkdd = { userResponse: false }

function onLoad() {

    DupNum = URLlist.itemCount;
    Totalnum = BookmarksCount.getItemAtIndex(0).value;
    setMessage(DupNum, Totalnum);
    BookmarksCount.setAttribute('hidden','true');

    /*var messageAutoDelete = "";
    AutoDeleteAllDuplicates = WinArgs[3];

    if("arguments" in window && WinArgs.length > 0) {
	var listURL = WinArgs[0];
    }

    for(var i=0;i<listURL.length;i++){
	if(AutoDeleteSameFolder || AutoDeleteSelectedFolder){
	    if (! AutoDeleteDuplicatesBookmark(listURL[i])) addURL("Folderslist",listURL[i],i);
	} else addURL("Folderslist",listURL[i],i);
    }

    if (AutoDeletedBookmarkSameFolder>0 ){
	messageAutoDelete = DuplicatesBundle.getFormattedString("DuplicatesAutoDelete-SameFolder", [AutoDeletedBookmarkSameFolder]);
	alert(messageAutoDelete);
    }
    if (AutoDeletedBookmarkSelectedFolder>0 ){
	messageAutoDelete = DuplicatesBundle.getFormattedString("DuplicatesAutoDelete-SelectedFolder", [AutoDeletedBookmarkSelectedFolder]);
	alert(messageAutoDelete);
    }
*/
    if (URLlist.itemCount>15){URLlist.setAttribute('rows','15');}

    URLlist.setAttribute('onclick','ShowParentFolders(this.value);');
    URLlist.setAttribute('onkeypress','ShowParentFolders(this.value);');

    window.sizeToContent();

    window.addEventListener("keypress", searchEscape, true);

}

// Event Listener to detect escape. Escape close window only if no item is selected.
// If a folder is selected it needs three escape key press to close window.
function searchEscape(aEvent){
    //Bookmarkdd.myDump("Key pressed is: "+aEvent.keyCode);

    if (aEvent.keyCode && aEvent.keyCode == "27"){
	if (FolderslistID.selectedCount != 0) {
	    FolderslistID.clearSelection();
	    return;
	}

	if (URLlist.selectedCount != 0) {
	    document.getElementById("description-url").setAttribute('value',"");
	    removeAllItems("Folderslist");
	    URLlist.clearSelection();
	    return;
	}

	window.close();
    }
}

function addURL(listID,label,value) {
    var FolderslistID = document.getElementById(listID);
    FolderslistID.appendItem(label,value);
}

function setMessage(Num, Total){
    var message ="";
    try {
	message = DuplicatesBundle.getFormattedString("DuplicatesFound", [Num, Total]);
    }  catch(e){
    	message = "You are using a localisation which is not supported !";
    }

    var messageParent = document.getElementById("Find-message");
    messageParent.setAttribute('value',message);
}


/* Fx3 ->ShowParentFolders
function ShowFolders(aEvent,aItem){
    //if(aEvent.button !=0) return false; //Why restrict use of button 0 ??
    var folders = null;

    removeAllItems("Folderslist");

    // Each time an item is selected 'isBookmarked' is executed.
    try {
	var urlFeed = rssFeed.exec(aItem.label);
	if (!urlFeed) {
	    folders = Bookmarkdd.isBookmarked(aItem.label);
	} else {
	    folders = Bookmarkdd.isBookmarked(aItem.label,aItem.label);
	}
    } catch(e) { return false; }

    SelectedURL = aItem;

    if(folders.parents) {
	URLParents = folders.parents;
	URLrdfNodes = folders.RDFnodes;
	URLnum = folders.parents.length;
    } else {
	Bookmarkdd.myDump("ShowFolders: impossible to find duplicate URLs !");
	return false;
    }
    if(URLnum > 1)  document.getElementById('b_delete').removeAttribute('disabled');
    if(URLnum == 2)  {
	FolderslistID.setAttribute('seltype','single');
    } else FolderslistID.setAttribute('seltype','multiple');

    for(var i=0;i<URLnum;i++){ addURL("Folderslist",URLParents[i],i); }

    document.getElementById("Folderslist").setAttribute('rows',eval(URLnum+1));
    var TruncatedUrl = aItem.label.substr(0,TRUNCATENUM);
    document.getElementById("description-url").setAttribute('value',TruncatedUrl);

    var WindowSizeMode = document.getElementById("bookmarkDD-ManageDuplicates").getAttribute('sizemode');
    //alert("Window Sizemode= "+WindowSizeMode);
    if(WindowSizeMode != "maximized"){
	window.sizeToContent();
    }

    return true;
}
*/

function removeAllItems(myListBox) {

    var box = document.getElementById(myListBox);
    var rowCount = box.getRowCount();
    for( var i = rowCount; i > 0; i-- ) {
	box.removeItemAt(0);
    }

}


function deleteSelection() {
    var count = FolderslistID.selectedCount;
    // selectedItems array start from 0 so we decrease of 1 before to start loop
    count--;
    for(var i=count;i>=0;i--){
	if(!removeURL(FolderslistID.selectedItems[i])) continue;
	FolderslistID.removeItemAt(FolderslistID.getIndexOfItem(FolderslistID.selectedItems[i]));

	if(URLnum < 3)  {
	    FolderslistID.setAttribute('seltype','single');
	} else FolderslistID.setAttribute('seltype','multiple');

	//If there is only one folder disable delete button to avoid remove of all URL references
	if (FolderslistID.getRowCount()<2) {
	    document.getElementById('b_delete').setAttribute('disabled','true');
	    URLlist.removeItemAt(URLlist.getIndexOfItem(URLlist.selectedItem));

	    removeAllItems("Folderslist");
	    document.getElementById("description-url").setAttribute('value',"");

	    DupNum--;
	    setMessage(DupNum, Totalnum);
	    return true;
	}
    }
    return true;
}

function removeURL(aItem){

    var URLPath = aItem.label;
    var message = DuplicatesBundle.getFormattedString("Remove-Confirmation", [document.getElementById("description-url").value, URLPath]);

    //default result=true --> If confirmation is not asked delete URL
    var result = true;
    if(UserPrefs.getPref("bool","removeURL.Askconfirmation")) result = BddConfirm(message);
    if (result) {
	//Remove bookmark in Bookmarks
	//XXX Stiffux: Comment following line to DEBUG
	bmsvc.removeItem(aItem.value);
	
	//URLnum--;
	Totalnum--;
	setMessage(DupNum, Totalnum);
	return true;
    }
    return false;
}

//BookmarkDD uses its own confirm window to replace default icon without overlay icon for all Browser's confirm
function BddConfirm(aText){

    //alert("aText "+aText);
    window.openDialog("chrome://duplicates/content/Fx3/ConfirmOverlay.xul", "BookmarkDD-Confirm", "chrome,modal,alwaysRaised,resizable,centerscreen", aText);

    return Bookmarkdd.userResponse;
}


function openbmProperties(aItem,aEvent){

    //Show Properties if context Click button --> rigth mouse click
    if (aEvent.button != 2) return false;
    PlacesUIUtils.showItemProperties(FolderslistID.selectedItem.value,"bookmark");
    
    return;
}


// If two duplicates bookmarks are in same folder delete the second found.
// OR if a duplicate bookmark is in selected folder delete it.
function AutoDeleteDuplicatesBookmark(aURL){
    var URLPath = new Array();
    var selectedFolder = UserPrefs.getPref("string","AutoDelete.SelectedFolder");
    var searchSelectedFolder = new RegExp("^("+selectedFolder+")","i");

    /*  PROTECTION:
    *	There is always duplicate that user want to keep. So this is a protection to avoid to delete ALL.
    *   Selection of root Folder 'Bookmarks' will delete ONLY duplicates which aren't in subfolders.
    */
    if (!isNotRootFolder.exec(selectedFolder)) {
	searchSelectedFolder = new RegExp("^("+selectedFolder+")$","i");
    }

    var folders = null;
    var urlFeed = rssFeed.exec(aURL);
    if (!urlFeed) {
	folders = Bookmarkdd.isBookmarked(aURL);
    } else {
	folders = Bookmarkdd.isBookmarked(aURL,aURL);
    }

    var num = 0;
    if(folders.parents) {
	var URLParents = folders.parents;
	var URLrdfNodes = folders.RDFnodes;
	num = folders.parents.length;
    } else {
	//If there is no duplicate for this URL don't add it in URLlist --> return true
	//Exemple: http://bugzilla.mozdev.org/show_bug.cgi?id=14589#c6
	Bookmarkdd.myDump("AutoDeleteDuplicatesBookmark: impossible to find duplicate URLs for:"+ aURL);
	return true;
    }
    
    for (var i=0;i<folders.parents.length; i++){
	var alreadyIn = false;

	/*
	*   Delete ALL Duplicates URL if AutoDeleteAllDuplicates = true 
	*/
	if(AutoDeleteAllDuplicates) {
	    if(num > 1) {
		//Remove bookmark in Bookmarks
		Bookmarkdd.myDump("(AutoDeleteAllDuplicates) Deleted URL: "+aURL+" duplicate in selected folder: "+URLParents[i]);
		var selection = Bookmarkdd.createSelection(URLrdfNodes[i]);
		BookmarksCommand.deleteBookmark(selection);
		AutoDeletedBookmarkSelectedFolder++;
		num--; Totalnum--;
	    }
	    // If Auto Delete ALL Duplicates don't test AutoDeleteSameFolder && AutoDeleteSelectedFolder
	    continue;
	}

    	if(AutoDeleteSameFolder) {
	    if(Bookmarkdd.version == "1.5"){
		    if(URLPath.indexOf(URLParents[i]) != -1) alreadyIn = true;
	    } else {
		    for (var count = 0; count < URLPath.length;count++){
			    if(!URLPath[count]) continue;
			    if(URLPath[count] == URLParents[i]) { alreadyIn = true; break; }
		    }
	    }

	    if(alreadyIn) {
		//Remove bookmark in Bookmarks
		Bookmarkdd.myDump("Deleted URL: "+aURL+" duplicate in same folder: "+URLParents[i]);
		var selection = Bookmarkdd.createSelection(URLrdfNodes[i]);
		BookmarksCommand.deleteBookmark(selection);
		AutoDeletedBookmarkSameFolder++;
		num--; Totalnum--;
		continue;
	    }
	}

	//if(filter(aURL,Folder)) continue;

	if(AutoDeleteSelectedFolder){
	    if(num > 1 && searchSelectedFolder.exec(URLParents[i])) {
		//Remove bookmark in Bookmarks
		Bookmarkdd.myDump("Deleted URL: "+aURL+" duplicate in selected folder: "+URLParents[i]);
		var selection = Bookmarkdd.createSelection(URLrdfNodes[i]);
		BookmarksCommand.deleteBookmark(selection);
		AutoDeletedBookmarkSelectedFolder++;
		num--; Totalnum--;
		continue;
	    }
	}

	if(!alreadyIn) {
	    if (Bookmarkdd.DEBUG) Bookmarkdd.myDump("Insert in URLPath array URL:\n"+aURL+"\nin folder tree:\n"+URLParents[i]);
	    URLPath.push(URLParents[i]);
	}
    }

    // If there is no more duplicate of this aURL, delete it in URLlist
    if( num == 1 ){
	DupNum--;
	setMessage(DupNum, Totalnum);
	return true;
    } else {
	if (Bookmarkdd.DEBUG) Bookmarkdd.myDump("Keep "+num+" copie(s) of URL: "+aURL);
    }

    return false;
}

// Find parents from URL and add Folders name in List
// aURI : url 
function ShowParentFolders(aURI) {
    // When escape is pressed or a click occurs on empty line aURI is null
    if(!aURI) return true;
 
    // Clear Parent Folder list before to show next list
    removeAllItems("Folderslist");

    // Transform URL in URI ressource
    var uri = ios.newURI(aURI, null, null);

    // Get all rows ID (from moz_bookmarks table) which get this URL
    // and search the Chain of parents
    var result = bmsvc.getBookmarkIdsForURI(uri, {});
    for (var i = 0;i < result.length; i++) {
	var parent_ID = bmsvc.getFolderIdForItem(result[i]);
	addURL("Folderslist",findPath(parent_ID),result[i]);
    }
    if(result.length < 3)  {
	FolderslistID.setAttribute('seltype','single');
    } else FolderslistID.setAttribute('seltype','multiple');

    // The if condition is not useful if URL list is refresh correctly after deletion
    // when there is only one parent for URL the delete button MUST be disabled
    if(result.length > 1)  document.getElementById('b_delete').removeAttribute('disabled');

    FolderslistID.setAttribute('rows',eval(result.length+1));
    var TruncatedUrl = aURI.substr(0,TRUNCATENUM);
    document.getElementById("description-url").setAttribute('value',TruncatedUrl);

    //XXX BUG Fx3 seems to not update sizemode to maximized when necessary !!!!!!
    var WindowSizeMode = document.getElementById("bookmarkDD-ManageDuplicates").getAttribute('sizemode');
    //alert("Window Sizemode= "+WindowSizeMode);
    if(WindowSizeMode != "maximized"){
	window.sizeToContent();
    }

    return true;
}

// Return a chain of URL Parent Folder Name
function findPath(aParentID) {
    var PathArray = new Array();
    var title = bmsvc.getItemTitle(aParentID);
    var boucle = true;
    PathArray.push(title);
    // ID=1 is the root ID of ALL moz_bookmarks table content
    while (aParentID > 1){
	aParentID = bmsvc.getFolderIdForItem(aParentID);
	if (aParentID > 1){
	    title = bmsvc.getItemTitle(aParentID);
	    PathArray.push(title);
	}
    }
    PathArray.reverse();

    return PathArray.join(" > ");
}

